#include  <qbitarray.h>
#include  <stdio.h>

//................................................................... funk1
QBitArray funk1(QBitArray a, QBitArray b, QBitArray s)
{
   return( s | (~a & ~b) );
}

//................................................................... funk2
QBitArray funk2(QBitArray a, QBitArray b, QBitArray s)
{
   return( ~( (a | b) & ~s) );
}

//.................................................................... main
int  main(void)
{
    uint i;
    QBitArray  a(8), b(8), s(8), f1(8), f2(8);
    
    for ( i=0; i<8; i++) {
       a.setBit( i, i>3 );
       b.setBit( i, i % 4 < 2 ? 0 : 1 );
       s.setBit( i, i%2 );
    }
    f1 = funk1( a, b, s );
    f2 = funk2( a, b, s );

    printf("------------------------------------------\n");
    printf(" a  b  s     s + (-a * -b)    -((a+b)*-s)\n");
    printf("------------------------------------------\n");

    for ( i=0; i<8; i++) {
        printf("%2d", a.at(i) ? 1 : 0 );
        printf("%3d", b.at(i) ? 1 : 0 );
        printf("%3d", s.at(i) ? 1 : 0 );
        printf("%12d", f1.at(i) ? 1 : 0 );
        printf("%16d", f2.at(i) ? 1 : 0 );
        printf("\n");
    }
    printf("------------------------------------------\n");
    printf("                          + = bitweises OR\n"
           "                          * = bitweises AND\n"
           "                          - = bitweise Negation\n");

    return 0;
}
