#include  "bruch.h"
#include  "bruchio.h"
#include  <iostream>

using namespace std;
//............................................................. main
int  main(void)
{
   CBruch   b1, b2;
   char     wahl;
   CBruchIO bio;  // Fr die Ein- und Ausgabe eines Bruches wird
                  // eine eigene Klasse verwendet, da dies nichts
                  // mit der Funktionalitt der Bruchklasse zu tun
                  // hat. Wird die Ein- / Ausgabeform geaendert,
                  // bleibt die Bruchklasse davon unberuehrt.

   cout << "     Bruchrechner" << endl
        << "     ============";

   while (1) {
      cout << "\n\nFunktionen:\n"
           << "   0  : NULL Stellen / 1. Bruch eingeben\n"
           << "   +  : Addieren\n"
           << "   -  : Subtrahieren\n"
           << "   *  : Multiplizieren\n"
           << "   /  : Dividieren\n"
           << "   k  : Kuerzen\n"
           << "   e  : Ende\n"
           << "Was wollen Sie tun?: ";
      cin >> wahl;

      switch(wahl) {
         case '0':  bio.In(b1);             break;
         case '+':  bio.In(b2); b1.Add(b2); break;
         case '-':  bio.In(b2); b1.Sub(b2); break;
         case '*':  bio.In(b2); b1.Mul(b2); break;
         case '/':  bio.In(b2); b1.Div(b2); break;
         case 'k':  b1.Kuerzen();           break;
         case 'e':
            return 0;  // Return, damit lokale Objekte freigegeben werden
                       // (passiert bei exit nicht!)
            break;
         default:
            break;
      }

      cout << "= ";
      bio.Out(b1);
   }
   return 0;
}
