#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qevent.h>
#include <stdlib.h>
#include <time.h>

//...................................................... Klasse ElternFenster
class ElternFenster : public QWidget
{
public:
   ElternFenster() {
      QLabel      *l;
      QPushButton *b;

      ::srand( time( NULL ) );
      setGeometry( 50, 50, 500, 500 );
      wieviel = 0;
      for ( int i=0; i<24; i++ ) {
         int  x = ::rand()%450,
              y = ::rand()%450;
         l = new QLabel( this );
         l->setGeometry( x, y, 50, 50 );
         l->setAlignment( AlignCenter );
         l->setPaletteBackgroundColor(QColor(rand()&255, rand()&255, rand()&255));
         l->setFrameStyle( QFrame::Box | QFrame::Sunken );
         l->setLineWidth( 2 );
         l->show();
         qApp->processEvents();
         wieviel++;

         b = new QPushButton( this );
         b->setGeometry( x, y, 50, 50 );
         QObject::connect( b, SIGNAL( clicked() ), b, SLOT( close() ) );
         b->show();
         qApp->processEvents();
         wieviel++;
      }
   }

protected:
   virtual void childEvent( QChildEvent *ev ) {
      QString  t;
      t.sprintf( "%d", wieviel/2+1 );
      if ( ev->inserted() )
         if ( wieviel % 2 )
            ( (QPushButton *)ev->child())->setText( t );
         else
            ( (QLabel *)ev->child())->setText( t );
   }

private:
   int   wieviel;
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );
   ElternFenster* mywidget = new ElternFenster();
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
