#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpointarray.h>
class malFenster : public QWidget {
 public:
    malFenster() {
       setCaption( "Demo zu Clipping" );
       setPaletteBackgroundColor( Qt::green.light(180) );
       resize( 550, 500 );
    }
 protected:
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );
       p.setClipRect( 50, 50, 200, 100 ); //.. Rechteckiges Clipping
       p.setPen( Qt::DashLine );
        p.drawRect( 50, 50, 200, 100 );
        p.setPen( Qt::red );
        p.setBrush( Qt::blue.light( 180 ) );
        p.drawEllipse( 0, 0, 250, 150 );
       p.setBrush( Qt::NoBrush );     //.. auch Rechteckiges Clipping
       p.setClipRegion( QRegion( 300, 50, 200, 100 ) );
        p.setPen( QPen( Qt::black, 0, Qt::DashLine) );
        p.drawRect( 300, 50, 200, 100 );
        p.setPen( Qt::red );
        p.setBrush( Qt::blue.light( 180 ) );
        p.drawEllipse( 250, 0, 250, 150 );
       p.setBrush( Qt::NoBrush );     //.. Ellipsenfoermiges Clipping
       p.setClipRegion( QRegion( 50, 200, 200, 100, QRegion::Ellipse ) );
        p.setPen( QPen( Qt::black, 0, Qt::DashLine) );
        p.drawEllipse( 50, 200, 200, 100 );
        p.setPen( Qt::red );
        p.setBrush( Qt::blue.light( 180 ) );
        p.drawRect( 0, 130, 200, 150 );
       p.setClipRect( 0, 0, 500, 500 );    //...... Dreiecks-Clipping
        p.setBrush( Qt::NoBrush );
        QPointArray a( 3 );
        a.setPoints( 4, 300, 300, 500, 300, 400, 200, 300, 300 );
        p.setPen( QPen( Qt::black, 0, Qt::DashLine) );
        p.drawPolygon( a );
        p.setClipRegion( a );
        p.setPen( Qt::red );
        p.setBrush( Qt::blue.light( 180 ) );
        p.drawRect( 250, 230, 200, 150 );
                                    //... Clipping ueber Vereinigung
       QRegion r1( 50, 350, 100, 100, QRegion::Ellipse );
       QRegion r2( 150, 350, 100, 100, QRegion::Ellipse );
       QRegion r3 = r1 | r2;
       p.setClipRegion( r3 );
       p.drawEllipse( 60, 360, 180, 80 );
                                    //... Clipping ueber Durchschnitt
       QRegion rd1( 250, 350, 150, 100, QRegion::Ellipse );
       QRegion rd2( 350, 350, 150, 100, QRegion::Ellipse );
       QRegion rd3 = rd1 & rd2;
       p.setClipRegion( rd3 );
       p.drawEllipse( 260, 360, 180, 80 );
    }
};
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
