#include <qwidget.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qcolordialog.h>
//............................................................... MeinFarbe
class MeinFarbe : public QWidget {
    Q_OBJECT
public:
    MeinFarbe::MeinFarbe() : QWidget( 0, 0) {
        setPaletteBackgroundColor( aktFarbe = Qt::white );
        farbeButton = new QPushButton( "Neue Farbe", this );
        connect( farbeButton, SIGNAL( clicked() ), SLOT( neueFarbe() ) );
        setGeometry( 0, 0, 400, 400 );
    }
private slots:
    void  neueFarbe() {
       QColor neuFarbe;
       neuFarbe = QColorDialog::getColor( aktFarbe, 0 );
       if ( neuFarbe.isValid() ) {
          setPaletteBackgroundColor( aktFarbe = neuFarbe );
          repaint();
       }
    }
private:
    QPushButton *farbeButton;
    QColor       aktFarbe;
};
#include "colordialog.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MeinFarbe *w = new MeinFarbe;
  w->show();
  a.setMainWidget( w );
  return a.exec();
}
