#include <stdio.h>
#include <iostream>
#include <iomanip>

using namespace std;
//.................................................. Klasse CStack .......
class CStack  
{
public:
   int  Pop();            // Oberstes Element von Stack holen
   bool Push(int iValue); // Element an oberster Stelle des Stacks ablegen
   bool isEmpty() { return m_TopIndex < 0; }  // Stack leer ? (inline)

   CStack(int maxEntries);           // Konstruktor
   ~CStack() { delete [] m_iStack; } // Destruktor (inline)

private:
   int * m_iStack;
   
   int m_MaxIndex;
   int m_TopIndex;

   bool init();
};

//........................................................... main .......
int main(void)
{
   CStack  stack(100);
   int     zeich;

   cout << "Bitte geben Sie einen String ein: " << endl;

   while ((zeich=getchar()) != '\n' && stack.Push(zeich))
      ;

   cout << "Der String lautet rueckwaerts:" << endl;

   while (!stack.isEmpty()) {
      zeich = stack.Pop();
      cout << (char)zeich;
   }

   cout << endl;

   return 0;
}

//................................................. 2. Konstruktor .......
CStack::CStack(int maxEntries)
{
   init();

   m_iStack = new int[maxEntries];
   if (m_iStack != NULL)
      m_MaxIndex=maxEntries-1;
}

//........................................................... init .......
bool CStack::init()
{
   m_MaxIndex = 0;
   m_TopIndex = -1;   // Stack ist zunaechst leer
   m_iStack = NULL;

   return true;
}

//........................................................... push .......
bool CStack::Push(int iValue)
{
   if(m_TopIndex == m_MaxIndex)
      return false;
   m_iStack[++m_TopIndex] = iValue;
   return true;
}

//............................................................ pop .......
int CStack::Pop()
{
   if (m_TopIndex < 0)
      return -1;
   return m_iStack[m_TopIndex--];
}
