#include <qapplication.h>
#include <qlistview.h>
#include <qsqldatabase.h>
#include <qsqlquery.h>

int main( int argc, char* argv[] ) {
   QApplication app( argc, argv );
    //... Verbindung zur Datenbank herstellen
   QSqlDatabase* adrVerwalt = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( adrVerwalt ) {
      adrVerwalt->setHostName( "localhost" );
      adrVerwalt->setDatabaseName( "adrVerwaltung" );
      adrVerwalt->setUserName( "root" );
      adrVerwalt->setPassword( "" );

      if ( adrVerwalt->open() ) { //... ffnen der Datenbank
          //... Erzeugen einer Listenansicht
         QListView adrView;
         app.setMainWidget( &adrView );
         adrView.addColumn( "Nachname" );
         adrView.addColumn( "Vorname" );
         adrView.addColumn( "Telefon" );
         adrView.addColumn( "Strasse" );
         adrView.addColumn( "PLZ" );
         adrView.addColumn( "Wohnort" );
         adrView.addColumn( "Geburtstag" );
         adrView.show();
          // Erzeugen und Ausfhren eines QUERY
         QSqlQuery query( "SELECT nachName, vorName, telNummer, strasse, "
                          "plz, wohnOrt, geburtsTag FROM privatAdressen;" );
         if ( query.isActive() ) {
            while ( query.next() ) {
               new QListViewItem( &adrView,
                       query.value( 0 ).toString(), query.value( 1 ).toString(),
                       query.value( 2 ).toString(), query.value( 3 ).toString(),
                       query.value( 4 ).toString(), query.value( 5 ).toString(),
                       query.value( 6 ).toString());
            }
         }
         return app.exec();
      } else
          adrVerwalt->lastError().showMessage( "Fehler bei Verbindung\n");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
