#... Anlegen einer neuen Datenbank
DROP DATABASE adrVerwaltung;
CREATE DATABASE adrVerwaltung;
USE adrVerwaltung;

#... Anlegen einer neuen Tabelle
DROP TABLE privatAdressen;

#... Festlegen der Tabellenstruktur fr privatAdressen
CREATE TABLE privatAdressen
(
   id          INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
   nachName    VARCHAR(40) NOT NULL,
   vorName     VARCHAR(30) NOT NULL,
   telNummer   VARCHAR(25) NOT NULL,
   strasse     VARCHAR(40) NOT NULL,
   plz         INT(5) NOT NULL,
   wohnOrt     VARCHAR(40) NOT NULL,
   geburtsTag  DATE NOT NULL
);
CREATE INDEX privatAdressen_nachname_index ON privatAdressen (nachName);
