#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlcursor.h>
#include <qdatatable.h>

int main( int argc, char* argv[] ) {
   QApplication app( argc, argv );
    //... Verbindung zur Datenbank herstellen
   QSqlDatabase* adrVerwalt = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( adrVerwalt ) {
      adrVerwalt->setHostName( "localhost" );
      adrVerwalt->setDatabaseName( "adrVerwaltung" );
      adrVerwalt->setUserName( "root" );
      adrVerwalt->setPassword( "" );

      if ( adrVerwalt->open() ) { //... ffnen der Datenbank
          // Erzeugen und Ausfhren eines QSqlCursor-Objekts
         QSqlCursor cursor( "privatAdressen" );
          // Anlegen und Fllen eines QDataTable-Widgets
         QDataTable *adrTabelle = new QDataTable( &cursor, true );
         adrTabelle->refresh();
         adrTabelle->show();
         app.setMainWidget( adrTabelle );
         int ret = app.exec();
         delete adrTabelle;
         return ret;
      } else
          adrVerwalt->lastError().showMessage( "Fehler bei Verbindung\n");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
