#include  <qapplication.h>
#include  <qheader.h>
#include  "dirbrows.h"

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );

    QListView fb;
    a.setMainWidget( &fb );

    fb.setCaption( "Directory Browser" );
    fb.header()->setPaletteBackgroundColor( QColor(100, 150, 200) );
    fb.addColumn( "Name" );
    fb.addColumn( "Type" );
    fb.addColumn( "Points to" );
    fb.addColumn( "Size" );
    fb.setColumnAlignment( 3, Qt::AlignRight );
    fb.addColumn( "Date" );
    fb.setColumnAlignment( 4, Qt::AlignRight );
    fb.addColumn( "Permissions" );
    fb.setColumnAlignment( 5, Qt::AlignRight );
    fb.resize( 800, 600 );

    Directory * root = new Directory( &fb );
    root->setOpen( true );

    fb.show();
    return a.exec();
}
