#include  <qdom.h>
#include  <qfile.h>
#include  <iostream>
using namespace std;
//.............................................................. printElement
void printElement( QDomElement docElem, QString indent ) {
   QDomNode n = docElem;
   while( !n.isNull() ) {
      QDomElement e = n.toElement(); // konvertiere Knoten in ein Element
      if( !e.isNull() ) {
          cout << indent << e.tagName() << endl;
          if ( !e.firstChild().isNull() )
             printElement( e.firstChild().toElement(), indent+"   " );
      }
      n = n.nextSibling();
   }
}
//...................................................................... main
int main( int argc, char *argv[] ) {
   QDomDocument doc;
   for ( int i=1; i<argc; i++ ) {
      QFile f( argv[i] );
      if ( !f.open( IO_ReadOnly ) )
         break;
      if ( !doc.setContent( &f ) ) { // Festlegen des Dokument-Inhalts
         f.close();
         break;
      }
      f.close();
      cout << endl << argv[i] << endl << "===========" << endl;
      printElement( doc.documentElement(), "" );
   }
   return 0;
}
