#ifndef LAYOUT9_H
#define LAYOUT9_H

#include  <qlabel.h>
#include  <qspinbox.h>
#include  <qbuttongroup.h>

const int zMax = 30;
const int sMax = 30;
const int allMax = zMax*sMax;

//....................................................... Klasse GridDemo
class GridDemo: public QWidget
{
    Q_OBJECT
public:
    GridDemo();
    ~GridDemo() { }

private slots:
    void neuZeilenSlot( int wert ) {      //..... neuZeilenSlot
       if (wert <= zMax) {
          z = wert;
          gesamt->setRange( 0, z*s );
          if (z*s < all)
             gesamt->setValue( z*s );
          zeigeBox();
       }
    }
    void neuSpaltenSlot( int wert ) {     //..... neuSpaltenSlot
       if (wert <= sMax) {
          s = wert;
          gesamt->setRange( 0, z*s );
          if (z*s < all)
             gesamt->setValue( z*s );
          zeigeBox();
       }
    }
    void neuGesamtSlot( int wert ) {       //..... neuGesamtSlot
       all = wert;
       zeigeBox();
    }

private:
    void        zeigeBox();
    QLabel      *l;
    QSpinBox    *spalten, *zeilen, *gesamt;
    QGridLayout *g;
    int          z, s, all;
};

#endif
