#include  <stdio.h>
#include  <string.h>

//............................................. Basisklasse Mensch
class Mensch
{
public:
   Mensch(char *name, int alter) {
      strcpy(m_Name, name);
      m_Alter = alter;
   }
   void gibNameAlterAus(void) {
      printf("%s: ist %d Jahre alt und hat ", m_Name, m_Alter);
   }
private:
   char m_Name[50];
   int  m_Alter;
};

//...................................... Klasse Frau (erbt Mensch)
class Frau : public Mensch
{
public:
   Frau(char *name, int alter, bool kinder) : Mensch(name, alter) {
      m_Kinder = kinder;
   }
   void fraudaten() {
      gibNameAlterAus();
      printf("%sKinder\n", m_Kinder ? "" : "keine ");
   }
private:
   bool m_Kinder; 
};

//...................................... Klasse Mann (erbt Mensch)
class Mann : public Mensch
{
public:
   Mann(char *name, int alter, bool bart) : Mensch(name, alter) {
      m_Bart = bart;
   }
   void manndaten() {
      gibNameAlterAus();
      printf("%seinen Bart\n", m_Bart ? "" : "k");
   }
private:
   bool m_Bart;
};

//................................ Klasse Ehe (erbt Mann und Frau)
class Ehe : public Frau, public Mann
{
public:
   Ehe(char *fname, int falter, bool kinder,
       char *mname, int malter, bool bart, int jahre) :
           Frau(fname, falter, kinder), Mann(mname, malter, bart) {
      m_Jahre = jahre;
   }
   void ehedaten() {
      fraudaten();
      manndaten();
      printf("Sie sind seit %d Jahre verheiratet\n", m_Jahre);
      printf("---------------------------------------------\n");
   }
private:
   int m_Jahre;
};

//.......................................................... main 
int main(void)
{
   Ehe  e1("Vera", 35, true, "Hans", 39, false, 12),
        e2("Kerstin", 63, true, "Otto", 66, true, 34);

   e1.ehedaten();
   e2.ehedaten();

   return 0;
}
