#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <qbuffer.h>
#include  <ctype.h>
#include  <iostream.h>

int  main( int argc, char *argv[] )
{
   char      dateiname[100];
   QString   msg;

   QApplication a( argc, argv );

   cout << "Dateiname: ";
   cin  >> dateiname;

   QFile datei( dateiname );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geoeffnet werden", dateiname );
      QMessageBox::information( 0, "Fehler beim Oeffnen der Datei",
                                msg, QMessageBox::Ok );
      return 1;
   }

   char     zeile[1024];
   QBuffer  buffer;
   int      r;

   buffer.open( IO_ReadWrite );

   while ( ( r = datei.readBlock( zeile, 1024 ) ) != 0 ) { 
      if ( r == -1 ) {
         if ( !datei.atEnd() ) {
            msg.sprintf( "Fehler beim Lesen der Datei `%s'", dateiname );
            QMessageBox::information( 0, "Fehler beim Lesen",
                                      msg, QMessageBox::Ok );
            return 2;
         } else
            break;
      } else {
         buffer.at( buffer.size() );
         buffer.writeBlock( zeile, r );
      }
   }
   datei.close();

   int    von, bis;
   int    zeich;
   do {
      cout << "Ausgabe ab Bytenr (Ende=-1) ? ";
      cin >> von;

      if ( von >= 0 ) {
         cout << "       bis Bytenr ? ";
         cin >> bis;
         cout << "Ausgabe der Datei " << dateiname << " (von Bytenr "
              << von << " bis " << bis << ")" << endl;
         cout << "---------------------------" << endl;
         while (von <= bis) {
            if (  buffer.at( von ) && (zeich = buffer.getch() ) > 0 )
               cout << (char)zeich;
            else
               break;
            von++;
         }
         cout << endl << "---------------------------" << endl << endl;
      }
   } while ( von >= 0 );

   return(0);
}
