#include <qapplication.h>
#include <qiconview.h>
#include <qpixmap.h>
#include <qdir.h>

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    QIconView iconview;
    QIconViewItem *item;

    iconview.setSelectionMode( QIconView::Extended );

    QDir dir( ".", "*.xpm" );
    for (uint i=0; i < dir.count(); i++) {
       item = new QIconViewItem( &iconview, dir[i], QPixmap( dir[i] ) );
       item->setRenameEnabled( true );
    }
    iconview.setCaption( "Iconview" );
    a.setMainWidget( &iconview );
    iconview.resize( 400, 400 );
    iconview.show();
    return a.exec();
}
