#include <qpushbutton.h>
#include <qlayout.h>
#include <qapplication.h>
//............................................................. MeinLayout
class MeinLayout : public QWidget {
  public:
     MeinLayout( QWidget *p=0, const char *nam=0 ) : QWidget( p, nam ) {
           //......................... Anlegen eines blauen Buttons
        QPushButton* b1 = new QPushButton( "blau", this );
          b1->setPaletteBackgroundColor( Qt::blue );
          b1->setPaletteForegroundColor( Qt::white);
          b1->setFixedHeight( 150 );
           //........................ Anlegen eines gruenen Buttons
        QPushButton* b2 = new QPushButton( "gruen", this );
          b2->setPaletteBackgroundColor( Qt::green );
          b2->setFixedHeight( 150 );
           //...................... Anlegen eines schwarzen Buttons
        QPushButton* b3 = new QPushButton( "sehr schwarz", this );
          b3->setPaletteBackgroundColor( Qt::black );
          b3->setPaletteForegroundColor( Qt::white);
          b3->setFixedHeight( 150 );
           //.......................... Anlegen eines roten Buttons
        QPushButton* b4 = new QPushButton( "rot", this );
          b4->setPaletteBackgroundColor( Qt::red );
          b4->setPaletteForegroundColor( Qt::white);
          b4->setFixedHeight( 150 );
           //......................... Anlegen eines gelben Buttons
        QPushButton* b5 = new QPushButton( "gelb", this );
          b5->setPaletteBackgroundColor( Qt::yellow );
          b5->setFixedHeight( 150 );
           //................... Toplevel-Layout-Manager (vertikal)
        QBoxLayout* toplayout = new QVBoxLayout( this );
           //... Zwei horizontale Layout-Manager erzeugen, die durch
           //.............. Toplevel-Layout-Manager verwaltet werden
        QBoxLayout* hlayout_oben  = new QHBoxLayout( toplayout );
        QBoxLayout* hlayout_unten = new QHBoxLayout( toplayout );
           //.. Oberen Layout-Manager die ersten 2 Buttons zuordnen
        hlayout_oben->addWidget( b1, 1 );
        hlayout_oben->addWidget( b2, 3 );
           // Unteren Layout-Manager die letzten 3 Buttons zuordnen
        hlayout_unten->addWidget( b3, 2 );
        hlayout_unten->addWidget( b4, 0 );
        hlayout_unten->addWidget( b5, 3 );
     }
};
//................................................................... main
int main( int argc, char *argv[] ) {
   QApplication a( argc, argv );
   MeinLayout  *ml = new MeinLayout;
   a.setMainWidget( ml );
   ml->setFixedHeight( 150 );
   ml->show();
   return a.exec();
}
