#include <qmap.h>
#include <qstring.h>
#include <iostream>
 
class Person {
    public:
        Person(): a(0) {}
        Person( const QString& name, int age ) : n(name), a(age) {}
 
        QString  name()  const       { return n; }
        int      age() const         { return a; }
        void     setAge( int age )   { a = age; }
    private:
        QString  n;
        int      a;
};
 
int main( void )
{
   typedef QMap<QString,Person> PersonMap;
   PersonMap map;

   map.insert( "Meier", Person("Hans", 50) );
   map.insert( "Schroeder", Person("Laura", 12) );
   map.insert( "Rauscher", Person("Toni",  46) );

   Person fritz( "Fritz", 36 );
   map.insert( "Kohler", fritz );
   fritz.setAge( 29 ); // keine Auswirkung auf Eintrag in QMap

   PersonMap::Iterator it;

   for( it = map.begin(); it != map.end(); ++it ) {
      std::cout << it.key().latin1() << ", " << it.data().name().latin1();
      std::cout << " ist " << it.data().age() << " alt" << "\n";
   }

   return 0;
}
