#include  <stdio.h>

//.............................................. Basisklasse Datum
class Datum
{
protected:
   int tag, monat, jahr;
public:
   Datum( int t, int m, int j ) { tag = t; monat = m; jahr = j; }
   virtual void ausgeben() {
      printf("%02d.%02d.%02d", tag, monat, jahr);
   }
};

//............................................... Basisklasse Zeit
class Zeit
{
protected:
   int std, min, sek;
public:
   Zeit( int h, int mi, int s ) { std = h; min = mi; sek = s; }
   virtual void ausgeben() {
      printf("%02d:%02d:%02d", std, min, sek);
   }
};

//......................... Klasse Zeitpunkt (erbt Datum und Zeit)
class Zeitpunkt : public Datum, public Zeit
{
public:
   Zeitpunkt(int t, int m, int j, int h, int mi, int s)
            : Datum(t, m, j), Zeit(h, mi, s) { }
   void ausgeben() {
      Datum::ausgeben(); // Aufruf von Datum-ausgeben
      printf(", ");
      Zeit::ausgeben();  // Aufruf von Zeit-ausgeben
   }
};

//........................................................... main
int main(void)
{
   Zeitpunkt  z(24, 12, 2004, 16, 35, 9);

   z.ausgeben();        printf("\n");
   z.Datum::ausgeben(); printf("\n");
   z.Zeit::ausgeben();  printf("\n");

   return 0;
}
