#include <qapplication.h>
#include <qmessagebox.h>
#include <qpixmap.h>

//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app( argc, argv );

    int w, wahl;

    const char* name[]= { "France", "Britain", "Germany",
                          "Italy",  "Spain",   "USA",     "None" };

    wahl = QMessageBox::information( 0, "Lnderwahl", "Whle Dein Land",
                                     "France", "Britain", "Weiter", 2, 0 );
    if ( wahl == 2 ) {
       w = QMessageBox::information( 0, "Lnderwahl", "Whle Dein Land",
                                     "Germany", "Italy", "Weiter", 2, 0 );
       wahl += w;
       if ( wahl == 4 ) {
          w = QMessageBox::information( 0, "Lnderwahl", "Whle Dein Land",
                                          "Spain", "USA", "None", 2, 0 );
          wahl += w;
       }
    }

    QString caption( "Deine Wahl" );
    QString info( name[wahl] );
    QString fileName( name[wahl] );
    fileName += ".xpm";

    if ( wahl < 6 ) {
        QPixmap bild;
        bild.load( fileName );
        QMessageBox *mb = new QMessageBox;
        mb->setCaption( caption );
        mb->setText( info );
        mb->setIconPixmap( bild );
        mb->exec();
    } else
        QMessageBox::critical( 0, caption, "keine Wahl" );

    return( 0 );
}
