#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>

#define nX  8
#define nY  8
//........................................................ Klasse malFenster
class malFenster : public QWidget {
  public:
    malFenster() { setBackgroundMode( NoBackground ); }
  protected:
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );
       p.setWindow( 0, 0, nX, nY );  //..... 8x8 Schachbrett
       for ( int i = 0; i < nX; i++ )
          for ( int j = 0; j < nY; j++ )
             if ( (i+j)%2 != 0 )
                p.fillRect( j, i, 2, 2, QBrush(Qt::blue, Qt::SolidPattern) );
             else
                p.fillRect( j, i, 2, 2, QBrush(Qt::yellow, Qt::SolidPattern) );
    }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setGeometry( 100, 100, 200, 200 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
