#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <stdio.h>

int  main( int argc, char *argv[] )
{
   QString      msg;
   QApplication a( argc, argv );

   if (argc != 2) {
      msg.sprintf( "usage:  %s dateiname", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   QFile datei( argv[1] );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[1] );
      QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                msg, QMessageBox::Ok );
      return 2;
   } else {
      QString zeile;
      int     r, zeilnr = 0;
      while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
         if ( r == -1 ) {
            if ( !datei.atEnd() ) {
               msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[1] );
               QMessageBox::information( 0, "Fehler beim Lesen",
                                         msg, QMessageBox::Ok );
               return 3;
            } else
               break;
         } else
            fprintf(stdout, "%5d  %s", ++zeilnr, (const char *) zeile);         
      }
      datei.close();
   }
   return 0;
}   
