#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <qtextstream.h>

int  main( int argc, char *argv[] ) {
   QString      msg;
   QApplication a( argc, argv );

   if (argc != 2) {
      msg.sprintf( "usage:  %s dateiname", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }
   QFile datei( argv[1] );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geoeffnet werden", argv[1] );
      QMessageBox::information( 0, "Fehler beim Oeffnen der Datei",
                                msg, QMessageBox::Ok );
      return 2;
   } else {
      int     zeilnr = 0;
      QString zeile;

      QTextStream inStream( &datei );
      QTextStream outStream( stdout, IO_WriteOnly );

      while ( !inStream.atEnd() ) { 
         zeile = inStream.readLine();
         outStream.width( 5 );
         outStream << ++zeilnr << "  " << zeile << endl;
      }
      datei.close();
   }
   return 0;
}   
