#include <qapplication.h>
#include <qprogressbar.h>
#include <qslider.h>

//................................................... Klasse ProgressBar
class ProgressBar : public QWidget {
    Q_OBJECT

public:
    ProgressBar( QWidget *parent=0, const char *name=0 )
                                              : QWidget( parent, name ) {
       progress = new QProgressBar( 1000, this );
       progress->setCenterIndicator ( true );
       progress->setGeometry( 50, 50, 300, 50);
       progress->setFont( QFont( "Helvetica", 30 ) );
       progress->setProgress( 0 );

       schieb = new QSlider( 0, 1000, 1, 0, QSlider::Horizontal, this );
       schieb->setGeometry( 50, 100, 300, 50);

       connect( schieb,   SIGNAL( valueChanged( int ) ),
                progress, SLOT( setProgress( int ) ) );
    }

protected:
    QSlider       *schieb;
    QProgressBar  *progress;
};

#include "progressbar2.moc"

//................................................................. main
int main( int argc, char *argv[] ) {
    QApplication a(argc,argv);

    ProgressBar progressbar;
    progressbar.resize(400,200);
    progressbar.setCaption("bung zu QProgressBar");
    a.setMainWidget(&progressbar);
    progressbar.show();

    return a.exec();
}
