#include <qstring.h>
#include <qptrlist.h>
#include <qstringlist.h>
#include <stdio.h>

//...................................................... Klasse Angestellter
class Angestellter {

public:
    Angestellter( const QString& name, int verdienst ) { n=name; v=verdienst; }
    QString     name()      const                      { return n; }
    int         verdienst() const                      { return v; }
private:
    QString     n;
    int         v;
};

//..................................................................... main
int  main( void )
{
   Angestellter *angest;
   QPtrList<Angestellter> liste;     // Liste von Zeigern auf Angestellter

   liste.append( new Angestellter("Meyer Hans", 32000) );
   liste.append( new Angestellter("Aller Antonia", 37150) );
   liste.append( new Angestellter("Kohler Fritz", 52000) );

   for ( angest=liste.first(); angest != 0; angest=liste.next() )
      printf( "%20s: %6d Euro\n", angest->name().ascii(), angest->verdienst() );
   printf("\n");

   return 0;
}
