#ifndef TEXTSIZEIMPL_H
#define TEXTSIZEIMPL_H

#include <qlabel.h>
#include <qslider.h>
#include "textsize4.h"

class TextSizeImpl : public TextSize
{
    Q_OBJECT
public:
    TextSizeImpl( QWidget* parent = 0, const char* name = 0,
                  bool modal = false, WFlags f = 0 ) :
                            TextSize( parent, name, modal, f ) {
       mySlider->setValue( 80 );
       textShow->setPaletteBackgroundColor( Qt::black );
       textShow->setPaletteForegroundColor( Qt::white );
    }
public slots:
    virtual void changeTextSizeSlot( int size );
};

#endif
