#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
public:
    malFenster() { setPalette( QPalette( Qt::white, Qt::white ) ); }

protected:
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );

       p.setPen( QPen( Qt::lightGray ) );
       for (int i = 10; i < 200; i+=10) { // Gitternetzlinien malen
          p.drawLine( 0, i, 200, i );
          p.drawLine( i, 0, i, 200 );
       }
       p.setPen( QPen( Qt::black ) );
       p.setBrush( QBrush( Qt::black, Qt::SolidPattern ) );
       p.drawRect( 20, 20, 100, 100 ); 
       p.shear( 0.5, 0.1 );
       p.setBrush( QBrush( Qt::white, Qt::SolidPattern ) );
       p.drawRect( 20, 20, 100, 100 ); 
    }
};

//..................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setGeometry( 100, 100, 200, 200 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
