#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <math.h>
//........................................................ Klasse malFenster
class malFenster : public QWidget {
  protected:
    void paintEvent( QPaintEvent * ) {
       const double  pi = 4 * atan(1),
                     faktor = pi/180;
       QPainter  p( this );
       p.setWindow( -360, -1000, 720, 2000 );
       p.drawLine( -360, 0, 360, 0 );   //... x-Achse
       p.drawLine( 0, -1000, 0, 1000 ); //... y-Achse
       p.setPen( Qt::blue );
       double letztY = -sin(360*faktor)*1000;
       for ( int i=-359; i<=360; i++ ) {
          p.drawLine( i-1, int(letztY), i, int(-sin(i*faktor)*1000) );
          letztY = -sin(i*faktor)*1000;
       }
    }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setPaletteBackgroundColor( Qt::yellow.light( 180 ) );
    bild.setGeometry( 100, 100, 400, 200 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
