#include <qapplication.h>
#include <qwidget.h>
#include <math.h>
#include "functionplot.h"

int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   const  double pi = 4*atan(1);
   valuePair v;
   int       i=0, z=0;

   for ( double x=-2*pi; x<3*pi; x+=0.01 ) // Zaehlen der Werte
      z++;

   FunctionPlot* plotWindow = new FunctionPlot( z );
   plotWindow->resize( 500, 500 );
   for ( v.x=-2*pi; v.x<=3*pi; v.x+=0.01 ) {
      v.y = sin(v.x);
      plotWindow->setValue( i, v );
      i++;
   }

   plotWindow->plotIt();

   myapp.setMainWidget( plotWindow );
   plotWindow->show();
   return myapp.exec();
}
