#include <stdio.h>

void tausch_neues_c (int& a, int& b);
void tausch_altes_c (int* a, int* b);
void tausch_falsch  (int a, int b);

int main(void)
{
   int a_neuc = 3, b_neuc  = 5,
       a_altc = 3, b_altc = 5,
       a      = 3,      b = 5;

   tausch_neues_c(a_neuc, b_neuc);
   tausch_altes_c(&a_altc, &b_altc);
   tausch_falsch (a, b);
   printf("Neues C (C++): a=%d, b=%d\n", a_neuc, b_neuc);
   printf("Altes C      : a=%d, b=%d\n", a_altc, b_altc);
   printf("       Falsch: a=%d, b=%d\n", a, b);

   return 0;
}

void tausch_neues_c(int& a, int& b)   //.... Echtes Call-by-Reference
{
   int hilf = a; 
   a = b;       
   b = hilf;
}

void tausch_altes_c(int* a, int* b)  //.... Kein echtes Call-by-Reference
{                                    //.... (Call-by-Value _ber Zeiger)
   int hilf = *a;
   *a = *b;
   *b = hilf;
}

void tausch_falsch(int a, int b)     //.... Call-by-Value 
{                                    //.... (kein Vertauschen der
   int hilf = a;                     //....  _bergebenen Argumente,
   a = b;                            //....  da diese nur temporaer
   b = hilf;                         //....  im Stack getauscht
}                                    //....  werden)
