#include <qthread.h>
#include <stdio.h>

const char *zahl[]   = { "Null", "Eins", "Zwei", "Drei",  "Vier" };
const char *number[] = { "Zero", "One",  "Two",  "Three", "Four" };
class MyThread : public QThread {
 public:
    MyThread( int nr ) : QThread() { id = nr; }

    virtual void run() {
       for (int i=0; i<5; i++) {
          sleep(1);
          if ( id == 1 )
             printf(" %s\n", zahl[i] );
          else
             printf(" %s\n------\n", number[i] );
       }
    }
 private:
    int id;
};
int main() {
    MyThread a(1);    MyThread b(2);
    a.start();        b.start();
    a.wait();         b.wait();
    return 0;
}
