#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qvaluestack.h>
#include  <qfile.h>
#include  <iostream>
#include  <string.h>

using namespace std;

int  main( int argc, char *argv[] )
{
   QString            msg;
   QValueStack<char>  zeilen;
   char               zeile[1000];

   QApplication a( argc, argv );

   if (argc != 2) {
      msg.sprintf( "usage:  %s datei", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   QFile datei( argv[1] );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[1] );
      QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                msg, QMessageBox::Ok );
      return 2;
   } else {
      int     r;
      while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
         if ( r == -1 ) {
            if ( !datei.atEnd() ) {
               msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[1] );
               QMessageBox::information( 0, "Fehler beim Lesen",
                                         msg, QMessageBox::Ok );
            } else
               break;
         } else {
            for ( uint i=0; i<strlen( zeile ); i++ )
               zeilen.push( zeile[i] );
         }
      }
      datei.close();
   }

   while ( !zeilen.isEmpty() )
      cout << zeilen.pop();

   return 0;
}
