#include <qdatetime.h>
#include <stdio.h>
#include <stdlib.h>
//.......................................................... datumAusgabe
void datumAusgabe( QString was, QDate datum ) {
   QDate millenium( 2000, 1, 1 );
   int  t = datum.day(),
        m = datum.month(),
        j = datum.year(),
        tm = datum.daysTo( millenium );

   printf("------ %s: %d.%d.%d\n"
       "  Dieser Tag ist ein `%s' und der %d. Tag des Jahres\n"
       "  Der Monatsname ist `%s' und dieser Monat hat `%d' Tage\n"
       "  Das Jahr %d hat %d Tage und ist%sein Schaltjahr\n"
       "  Die Stringdarstellung dieses Datums ist: %s\n"
       "  oder aber auch: %s\n"
       "  Dieses Datum liegt %d Tage %s dem Millenium\n\n",
       (const char *)was, t, m, j,
       (const char *)datum.shortDayName( datum.dayOfWeek() ), datum.dayOfYear(), 
       (const char *)datum.shortMonthName( m ), datum.daysInMonth(), 
       j, datum.daysInYear(), QDate::leapYear( j ) ? " " : " k",
       (const char *)datum.toString("dd.MMM.yy"),
       (const char *)datum.toString("ddd MMMM d yyyy"),
       abs(tm), tm > 0 ? "vor" : "nach" );
}
//.................................................................. main
int  main(void) {
  int tag, monat, jahr, diff;
   QDate heute( QDate::currentDate() ); //... Heutiges Datum
   QDate eingabeDatum;             //... einzugebendes Datum
   printf("Datum (tt.mm.jjjj): ");
   scanf("%d.%d.%d", &tag, &monat, &jahr);
   while ( !eingabeDatum.setYMD( jahr, monat, tag ) ) {
      printf("Ungueltiges Datum: %d.%d.%d\n", tag, jahr, monat);
      printf("Datum (tt.mm.jjjj): ");
      scanf("%d.%d.%d", &tag, &monat, &jahr);
   }
   printf("Wie viele Tage von heute: "); //... Datum in/vor x Tagen
   scanf("%d", &diff );
   QString s;
   s.sprintf( "Das Datum heute %s %d Tagen %s",
               diff >= 0 ? "in" : "vor", abs(diff),
               diff >= 0 ? "ist" : "war" );
   QDate diffDatum( QDate::currentDate().addDays( diff ) );
     //... Ausgabe der Daten zu den drei Dati
   datumAusgabe( "Heute ist", heute);
   datumAusgabe( "Das eingegebene Datum", eingabeDatum);
   datumAusgabe( s, diffDatum);
   return 0;
}
