#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qdict.h>
#include  <qfile.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

int  main( int argc, char *argv[] )
{
   QApplication a( argc, argv );
   QString      msg;
   QDict<int>   woerter( 9973, false );
   const char   *wort;
   const char   *trennzeichen = ".,;-:+*~'`=)(/{}[]&%$!?<>|\\#\"\t\n ";
   char         zeile[1000];
   int          *anzahl;

   if (argc < 2) {
      msg.sprintf( "usage:  %s datei(en)", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   for ( int i=1; i < argc; i++) {
         QFile datei( argv[i] );
      if ( !datei.open( IO_ReadOnly ) ) {
         msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[i] );
         QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                   msg, QMessageBox::Ok );
      } else {
         int     r;
         while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
            if ( r == -1 ) {
               if ( !datei.atEnd() ) {
                  msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[i] );
                  QMessageBox::information( 0, "Fehler beim Lesen",
                                            msg, QMessageBox::Ok );
               } else
                  break;
            } else {
               wort = strtok( zeile, trennzeichen);
               while (wort != NULL) {
                  anzahl = woerter.find( wort );
                  if ( !anzahl ) {
                     int  *eins = new int;
                     *eins = 1;
                     woerter.insert( wort, eins );
                  } else {
                     (*anzahl)++;
                     woerter.replace( wort, anzahl );
                  }
                  wort = strtok(NULL, trennzeichen);
               }
            }
         }
         datei.close();
      }
   }

   QDictIterator<int> it( woerter ); // Iterator fuer woerter
   while ( it.current() ) {
       printf( "%-20s: %3d\n", (const char *)it.currentKey(), *(it.current()) );
       ++it;
   }

   return 0;
}
