#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qrect.h>
//........................................................ Klasse malFenster
class malFenster : public QWidget {
protected:
    void paintEvent( QPaintEvent * ) {
       QString  text;
       QRect    ruo, // Koordinaten im urspruengl. KS (original)
                rao, // Koordinaten im aktuellen KS (original)
                rut, // Koordinaten im urspruengl. KS (transformiert)
                rat; // Koordinaten im aktuellen KS (transformiert)
       QPainter p( this );
        //.................................................. rotate
       p.setBrush( QBrush( Qt::black, Qt::SolidPattern ) );
        p.drawText( 5, 15, "rotate( 30.0 )" );
        p.drawRect( 81, 21, 100, 100 ); 
       rao = p.xFormDev( QRect( 81, 21, 100, 100 ) );
       ruo = p.xForm( QRect( 81, 21, 100, 100 ) );
       p.rotate( 30.0 ); //... Rotieren
       rat = p.xFormDev( QRect( 81, 21, 100, 100 ) );
       rut = p.xForm( QRect( 81, 21, 100, 100 ) );
       text.sprintf( "Ursprngliches Koordinatensystem:\n"
                     "         xForm: (%d,%d)....(%d,%d)\n"
                     "   xFormDev: (%d,%d)....(%d,%d)\n\n"
                     "Koord. zum ursprgl. Rechteck im transf. KS (blau):\n"
                     "      (%d,%d)....(%d,%d)\n\n"
                     "Koord. zum transform. Rechteck im ursprgl. KS (gelb):\n"
                     "      (%d,%d)....(%d,%d)\n",
                     ruo.left(), ruo.top(), ruo.right(), ruo.bottom(),
                     rao.left(), rao.top(), rao.right(), rao.bottom(),
                     rat.left(), rat.top(), rat.right(), rat.bottom(),
                     rut.left(), rut.top(), rut.right(), rut.bottom() );
       QLabel *l1 = new QLabel( this );
        l1->setGeometry( 250, 30, 320, 150 );
        l1->setFont( QFont( "Times", 12 ) );
        l1->setText( text );
        l1->show();
       p.setBrush( QBrush( Qt::white, Qt::SolidPattern ) );
        p.drawRect( 81, 21, 100, 100 ); 
       p.setBrush( QBrush( Qt::NoBrush ) );
        p.setPen( Qt::blue );
        p.drawRect( rat );
       p.rotate( -30.0 ); // Rotieren rueckgaengig
        p.setPen( Qt::yellow );
        p.drawRect( rut );
        //................................................... share
       p.setPen( Qt::black );
        p.setBrush( QBrush( Qt::black, Qt::SolidPattern ) );
        p.drawText( 120, 315, "shear( 0.5, 0.1)" );
        p.drawRect( 21, 321, 100, 100 ); 
       rao = p.xFormDev( QRect( 21, 321, 100, 100 ) );
       ruo = p.xForm( QRect( 21, 321, 100, 100 ) );
       p.shear( 0.5, 0.1 );  //... Scherung
       rat = p.xFormDev( QRect( 21, 321, 100, 100 ) );
       rut = p.xForm( QRect( 21, 321, 100, 100 ) );
       text.sprintf( "Ursprngliches Koordinatensystem:\n"
                     "         xForm: (%d,%d)....(%d,%d)\n"
                     "   xFormDev: (%d,%d)....(%d,%d)\n\n"
                     "Koord. zum ursprgl. Rechteck im transf. KS (blau):\n"
                     "      (%d,%d)....(%d,%d)\n\n"
                     "Koord. zum transform. Rechteck im ursprgl. KS (gelb):\n"
                     "      (%d,%d)....(%d,%d)\n",
                     ruo.left(), ruo.top(), ruo.right(), ruo.bottom(),
                     rao.left(), rao.top(), rao.right(), rao.bottom(),
                     rat.left(), rat.top(), rat.right(), rat.bottom(),
                     rut.left(), rut.top(), rut.right(), rut.bottom());
       QLabel *l2 = new QLabel( this );
        l2->setGeometry( 250, 330, 300, 150 );
        l2->setFont( QFont( "Times", 12 ) );
        l2->setText( text );
        l2->show();
       p.setBrush( QBrush( Qt::white, Qt::SolidPattern ) );
        p.drawRect( 21, 321, 100, 100 ); 
       p.setBrush( QBrush( Qt::NoBrush ) );
        p.setPen( Qt::blue );
        p.drawRect( rat );
       p.resetXForm(); // Scherung rckgngig
        p.setPen( Qt::yellow );
        p.drawRect( rut );
    }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setGeometry( 100, 100, 600, 500 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
