#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qarray.h>
#include  <qdict.h>
#include  <qfile.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

int  main( int argc, char *argv[] )
{
   QApplication a( argc, argv );
   QString      msg;
   const char   *wort;
   const char   *trennzeichen = ".,;-:+*~'`=)(/{}[]&%$!?<>|\\\"\t\n ";
   char         zeile[1000];

   if (argc < 2) {
      msg.sprintf( "usage:  %s datei(en)", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   QDict< QArray<QString *> > xref( 9973, false );
   QArray<QString *>         *elem;

   for ( int i=1; i < argc; i++) {
      QFile datei( argv[i] );

      if ( !datei.open( IO_ReadOnly ) ) {
         msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[i] );
         QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                   msg, QMessageBox::Ok );
      } else {
         int   r, 
               lineNo = 1;
         while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
            if ( r == -1 ) {
               if ( !datei.atEnd() ) {
                  msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[i] );
                  QMessageBox::information( 0, "Fehler beim Lesen",
                                            msg, QMessageBox::Ok );
               } else
                  break;
            } else {
               wort = strtok( zeile, trennzeichen);
               while (wort != NULL) {
                  elem = xref.find( wort );
                  if ( !elem ) {
                     QArray<QString *> *array = new QArray<QString *>(1);
                     QString  *s = new QString;
                     s->sprintf( "%-15s %d", argv[i], lineNo );
                     (*array).at(0) = s; 
                     xref.insert( wort, array );
                  } else {
                     uint index = elem->size();
                     QString oldName( argv[i] );
                     QString fileName = *((*elem).at(index-1));
                     fileName.truncate( fileName.find(' ') );

                     if ( oldName != fileName ) {
                        elem->resize( index + 1 );
                        (*elem).at(index) = new QString;
                        (*elem).at(index)->sprintf( "%-15s %d", argv[i], lineNo );
                     } else {
                        index--;
                        QString  *s = new QString;
                        s->sprintf( "%s, %d", (const char *)*((*elem).at(index)), lineNo );
                        delete (*elem).at(index);
                        (*elem).at(index) = s;
                     }
                  }
                  wort = strtok(NULL, trennzeichen);
               }
            }
            lineNo++;
         }
         datei.close();
      }
   }

   QDictIterator< QArray<QString *> > it( xref ); // Iterator fuer xref
   while ( it.current() ) {
      for ( uint j=0; j<it.current()->size(); j++ )
         printf( "%-20s: %s\n", (const char *)it.currentKey() ,
                                (const char *)*( (*it.current()).at(j)) );
      ++it;
   }

   return 0;
}
