#include  <stdio.h>

struct Bruch {
private:
    long  zaehler, nenner;

public:
    void  setze(int z, int n) { zaehler = z;  nenner = n; }
    long  hole_zaehler(void)  { return zaehler; }
    long  hole_nenner(void)   { return nenner;  }
    void  add(int z, int n);
    void  sub(int z, int n);
    void  mult(int z, int n);
    void  divi(int z, int n);
    void  kuerzen(void);
};

long  ggT(long n, long m) { return (m==0) ? n : ggT(m, n%m); }

int  main(void)
{
    struct Bruch  zahl;
    long   z, n;
    int    wahl, i = 2;

    printf("1. Bruch: "); scanf("%ld/%ld", &z, &n);
    zahl.setze(z, n);
    printf("2. Bruch: "); scanf("%ld/%ld", &z, &n);
    
    while (1) {
       do {
	   printf("\n\nDie beiden Brueche %ld/%ld und %ld/%ld\n",
		   zahl.hole_zaehler(), zahl.hole_nenner(), z, n);
	   printf(" 1 (addieren), 2 (subtrahieren),"
		   " 3 (multiplizieren), 4 (dividieren) ? ");
	   scanf("%d", &wahl);
	} while (wahl<1 || wahl>4);
	printf("....Ergebnis: %ld/%ld",
		zahl.hole_zaehler(), zahl.hole_nenner());

	if (wahl==1)      { printf(" + %ld/%ld", z, n); zahl.add (z, n); }
	else if (wahl==2) { printf(" - %ld/%ld", z, n); zahl.sub (z, n); }
	else if (wahl==3) { printf(" * %ld/%ld", z, n); zahl.mult(z, n); }
	else if (wahl==4) { printf(" / %ld/%ld", z, n); zahl.divi(z, n); }

	printf(" = %ld/%ld = ", zahl.hole_zaehler(), zahl.hole_nenner());

	zahl.kuerzen();
	printf("%ld/%ld (gekuerzt)\n--------------------------------\n",
		zahl.hole_zaehler(), zahl.hole_nenner());

	printf("%d. Bruch (0/0 = Ende): ", ++i);
	scanf("%ld/%ld", &z, &n);
	if (z== 0 || n== 0)
	   break;
    }
    return(0);
}

void Bruch::add (int z, int n) { zaehler=zaehler*n+nenner*z; nenner*=n; }
void Bruch::sub (int z, int n) { zaehler=zaehler*n-nenner*z; nenner*=n; }
void Bruch::mult(int z, int n) { zaehler*=z;                 nenner*=n; }
void Bruch::divi(int z, int n) { zaehler*=n;                 nenner*=z; }

void Bruch::kuerzen(void)
{
   long  ggTeiler = ggT(zaehler, nenner);

   zaehler /= ggTeiler;
   nenner  /= ggTeiler;
}
