#include  <string.h>
#include  <iostream>

using namespace std;

struct Zeichkette
{
                              //.................. Konstruktor
   Zeichkette( char *str, char *name )
   {
      zeichk = new char[strlen(str)+1]; // +1 wegen abschl. \0
      strcpy( zeichk, str);
      this->name = new char[strlen(name)+1]; // +1 wegen abschl. \0
      strcpy( this->name, name);
   }

   ~Zeichkette()              //.................. Destruktor
   {
      cout << ".... Aufruf von Destruktor fuer " << name << endl;
      delete zeichk;
      delete name;
   }
  
   void drucke( void )
   {
      cout << zeichk << endl;
   }

private:
   char *zeichk;
   char *name;
};

int main(void)
{
   Zeichkette  z1("Ich bin String1", "z1"),
               z2("Ich bin das Objekt z2", "z2"),
              *zz;

   zz = new Zeichkette("Ich bin ein Zeiger zz", "zz");
  
   z1.drucke();
   z2.drucke();
   zz->drucke();

   delete zz;  //... Destruktor fuer zz wird aufgerufen

   zz = new Zeichkette("Ich bin ein neuer Zeiger (wieder zz)", "zz");
   zz->drucke();
   delete zz;  //... Destruktor fuer zz wird wieder aufgerufen

   return 0;   //... Destruktoren fuer z1 und z2 werden hier
               //... automatisch aufgerufen
}
