#include  <iostream>
using namespace std;

class Dezimalziffer
{
public:
   Dezimalziffer(int z) { m_Ziffer = z; }
   void Ausgeben() { cout << "Dezimal: " << m_Ziffer << endl; }
private:
   int m_Ziffer;
};

class Hexaziffer : public Dezimalziffer
{
public:
   Hexaziffer(int z) : Dezimalziffer(z<10 ? z : z-'A'+10) {
      m_Ziffer = z;
   }
   void Ausgeben();
private:
   int m_Ziffer;
};

void Hexaziffer::Ausgeben()
{
   Dezimalziffer::Ausgeben();  // Aufrufen der Methode aus der Basisklasse
   cout << "Hexadezimal: ";
   cout << (char) m_Ziffer << endl;
}

int main(void)
{
   Dezimalziffer d(10);
   d.Ausgeben();

   Hexaziffer h('D');
   h.Ausgeben();

   return 0;
}
