#include <qdict.h>
#include <stdio.h>

int main()
{
   QDict<char> dict( 17, false );

   dict.insert( "Frankreich",  "Paris" );
   dict.insert( "Deutschland", "Berlin" );
   dict.insert( "Norwegen",    "Oslo" );
   dict.insert( "Italien",     "Rom" );

   QDictIterator<char> it( dict ); // Iterator fuer dict

   while ( it.current() ) {
       printf( "%-12s: %s\n", (const char *)it.currentKey(),
                              it.current() );
       ++it;
   }

   printf(" \n.... und ein zweites mal: \n" );
   it.toFirst();
   for ( uint i=0; i<it.count(); i++, ++it )
       printf( "%-12s: %s\n", (const char *)it.currentKey(),
                              it.current() );

   printf(" \n.... und ein letztes mal (nur Hauptstaedte): \n" );
   it.toFirst();
   while ( it.current() )
       printf( "%-12s\n", (const char *)it() );

   return 0;
}
