#ifndef FILEBROW_H
#define FILEBROW_H

#include  <qlistview.h>
#include  <qstring.h>
#include  <qfile.h>

class Directory: public QListViewItem {
  public:
    Directory::Directory( QListView *par);
    Directory::Directory( Directory *par, const char * filename );

    QString text( int c ) const;
    QString fullName();

    void setOpen( bool o );
    void setup();
  private:
    QFile      f;
    Directory* p;
    char       size[30], time[30], perm[4];
    bool       readable;
};
#endif
