#include  <qptrlist.h>
#include  <iostream>

using namespace std;

void  auszaehlen(int n, int z)
{
   QPtrList <int>  personCircle;
   int          i;
   bool         skipToBegin = true;

   personCircle.setAutoDelete( true );

   for (i=1; i<=n; i++) {
      int *nr = new int( i );
      personCircle.append( nr );
   }

   do { 
      if ( skipToBegin )
         personCircle.first();

      for (i=1; i<z; i++) {
         if ( personCircle.next() == NULL )
            personCircle.first();
      }

      cout << *personCircle.current() << ", ";

      skipToBegin = personCircle.current() == personCircle.getLast();
      personCircle.remove();

   } while ( !personCircle.isEmpty() );

   cout << endl;
}

int  main(void)
{
   int  n, z;

   cout << "Wie viele Personen: "; 
   cin >> n;
   cout << "Der wievielte soll immer ausgesondert werden: ";
   cin >> z;

   cout << endl << "In folgender Reihenfolge wird ausgesondert:" << endl;
   auszaehlen(n, z);

   return 0;
}
