#include  <qstring.h>
#include  <qtextstream.h>

void  rekursiv_spiegeln( QString& alt, QString& neu, uint i );

//............................................................... main
int  main(void)
{
   QString  alt, neu;
   long     von, bis;

   QTextStream eingabe( stdin, IO_ReadOnly );
   QTextStream ausgabe( stdout, IO_WriteOnly );

   ausgabe << "Palindrome durch Addition von Kehrzahlen" << endl
           << "========================================" << endl << endl;

   ausgabe << "Ab welcher Zahl: ";      eingabe >> von;
   ausgabe << "Bis zu welcher Zahl: ";  eingabe >> bis;
   ausgabe << endl;

   for (long i=von; i<=bis; i++) {
      alt.sprintf( "%ld", i );
      neu = "";
      rekursiv_spiegeln( alt, neu, 0);
      ausgabe << alt << "+" << neu;
      while (1) {
         alt.sprintf( "%ld", alt.toLong() + neu.toLong() );
         neu = "";
         rekursiv_spiegeln( alt, neu, 0 );
         if ( alt == neu ) {
            ausgabe << " = " << alt << endl;
            break;
         } else {
            ausgabe << "--> " << alt << "+" << neu;
            if ( alt.length() >= 9 ) {
               ausgabe << "= ....... Abbruch (Zahl zu gross)" << endl;
               break;
            }
         }
      }
   }
   return 0;
}

//.................................................. rekursiv_spiegeln
void  rekursiv_spiegeln( QString& alt, QString& neu, uint i )
{
   if ( i < alt.length() ) {
      QString zeich( alt.at(i) );
      rekursiv_spiegeln( alt, neu, i+1 );
      neu.append( zeich );
   } 
}
