#include <qapplication.h>
#include <qpushbutton.h>
#include <qlayout.h>
//............................................................. MeinLayout
class MeinLayout : public QWidget {
  public:
     MeinLayout( QWidget *parent = 0, const char *name=0 ) 
                                     : QWidget( parent, name ) {
        QHBoxLayout* layout = new QHBoxLayout( this );
              //..... Anlegen eines roten Buttons mit Stretch-Faktor 1
        QPushButton* b1 = new QPushButton( "rot (1)", this );
          b1->setPaletteBackgroundColor( Qt::red );
          b1->setFixedHeight( 200 );
          layout->addWidget( b1, 1 );
              //... Einfuegen eines festen Zwischenraums von 30 Pixeln
        layout->addSpacing( 30 );
              //... Anlegen eines gruenen Buttons mit Stretch-Faktor 2
        QPushButton* b2 = new QPushButton( "gruen (2)", this );
          b2->setPaletteBackgroundColor( Qt::green );
          b2->setFixedHeight( 200 );
          layout->addWidget( b2 );
          layout->setStretchFactor( b2, 2 );
           //.... Einfuegen einer leeren Stretch-Flache (Faktor=3)
        layout->addStretch( 3 );
           //.... Anlegen eines blauen Buttons mit Stretch-Faktor 4
        QPushButton* b3 = new QPushButton( "blau (4)", this );
          b3->setPaletteBackgroundColor( Qt::blue );
          b3->setFixedHeight( 200 );
          layout->addWidget( b3, 4 );
           //.... Anlegen eines gelben Buttons mit Stretch-Faktor 0
        QPushButton* b4 = new QPushButton( "gelb (0)", this );
          b4->setPaletteBackgroundColor( Qt::yellow );
          b4->setFixedHeight( 200 );
          layout->addWidget( b4, 0 );
     }
};
//................................................................... main
int main( int argc, char *argv[] ) {
   QApplication a( argc, argv );
   MeinLayout *mal = new MeinLayout;
   mal->setFixedHeight( 200 );
   mal->show();
   a.setMainWidget( mal );
   return a.exec();
}
