#include <qapplication.h>
#include <qlabel.h>
#include <qlayout.h>
//............................................................. MeinLayout
class MeinLayout : public QWidget {
  public:
     MeinLayout( QWidget *p=0, const char *nam=0 ) : QWidget( p, nam ) {
           //......................... Anlegen eines blauen Buttons
        QLabel* b1 = new QLabel( " blau ", this );
          b1->setPaletteBackgroundColor( Qt::blue );
          b1->setPaletteForegroundColor( Qt::white );
          b1->setAlignment( QLabel::AlignCenter );
           //........................ Anlegen eines gruenen Buttons
        QLabel* b2 = new QLabel( " gruen ", this );
          b2->setPaletteBackgroundColor( Qt::green );
          b2->setAlignment( QLabel::AlignCenter );
           //...................... Anlegen eines schwarzen Buttons
        QLabel* b3 = new QLabel( "schwarz", this );
          b3->setPaletteBackgroundColor( Qt::black );
          b3->setPaletteForegroundColor( Qt::white );
          b3->setAlignment( QLabel::AlignCenter );
           //.......................... Anlegen eines roten Buttons
        QLabel* b4 = new QLabel( "rot", this );
          b4->setPaletteBackgroundColor( Qt::red );
          b4->setPaletteForegroundColor( Qt::white );
          b4->setAlignment( QLabel::AlignCenter );
           //......................... Anlegen eines gelben Buttons
        QLabel* b5 = new QLabel( "gelb", this );
          b5->setPaletteBackgroundColor( Qt::yellow );
          b5->setAlignment( QLabel::AlignCenter );
           //........................ Anlegen eines weissen Buttons
        QLabel* b6 = new QLabel( "weiss", this );
          b6->setPaletteBackgroundColor( Qt::white );
          b6->setAlignment( QLabel::AlignCenter );
           //............. Grid-Layout (mit 2 Zeilen und 3 Spalten)
        QGridLayout* toplayout = new QGridLayout( this, 2, 3 );
           //.................. Einordnen der Buttons im Grid-Layout
        toplayout->addWidget( b1, 0, 0 );
        toplayout->addWidget( b2, 0, 1 );
        toplayout->addWidget( b3, 0, 2 );
        toplayout->addWidget( b4, 1, 0 );
        toplayout->addWidget( b5, 1, 1 );
        toplayout->addWidget( b6, 1, 2 );
           //.............. Stretch-Faktoren fuer Zeilen und Spalten
        toplayout->setRowStretch( 0, 1 );
        toplayout->setRowStretch( 1, 3 );
        toplayout->setColStretch( 0, 1 );
        toplayout->setColStretch( 1, 0 );
        toplayout->setColStretch( 2, 4 );
     }
};
//................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MeinLayout  *ml = new MeinLayout;
  a.setMainWidget( ml );
  ml->show();
  return a.exec();
}
