#include <qapplication.h>
#include <qlistview.h>

int main( int argc, char *argv[] ) {
   QApplication a( argc, argv);
   QListView* listview = new QListView();
   listview->addColumn( "Lebensort/Spezies" );
   listview->addColumn( "Name" );
   listview->addColumn( "Alter" );
   listview->setRootIsDecorated( true ); // zeigt anhand von Pfeilen an,
                          // ob eine Liste weitere Untereintraege
                          // enthaelt, und ob sie geffnet ist oder nicht
        //.... Zum Testen der entsprechenden Eigenschaften muessen in den
        //.... jeweiligen Zeilen die Kommentarzeichen entfernt werden
//   listview->setColumnWidthMode( 0, QListView::Manual );
//   listview->setAllColumnsShowFocus( true );
//   listview->setSelectionMode( QListView::Single );
//   listview->setSelectionMode( QListView::Multi );
//   listview->setSelectionMode( QListView::Extended );
//   listview->setSelectionMode( QListView::NoSelection );
   QListViewItem* landtier   = new QListViewItem( listview, "Landtier" );
   QListViewItem* wassertier = new QListViewItem( listview, "Wassertier" );
   QListViewItem* lufttier   = new QListViewItem( listview, "Lufttier" );

   QListViewItem* exemplar;
   QListViewItem* elefant = new QListViewItem( landtier, "Elefanten");
    exemplar = new QListViewItem( elefant, "", "Benjamin", " 7" );
    exemplar = new QListViewItem( elefant, "", "Rambo", " 9" );
    exemplar = new QListViewItem( elefant, "", "Zorro", " 7" );
   QListViewItem* tiger = new QListViewItem( landtier, "Tiger");
    exemplar = new QListViewItem( tiger, "", "Baika", "11" );
    exemplar = new QListViewItem( tiger, "", "Taifun", " 5" );
   QListViewItem* delphin = new QListViewItem( wassertier, "Delphine");
    exemplar = new QListViewItem( delphin, "", "Flopper", " 5" );
    exemplar = new QListViewItem( delphin, "", "Jumper", " 3" );
   QListViewItem* hai = new QListViewItem( wassertier, "Haie");
    exemplar = new QListViewItem( hai, "", "Dango", " 8" );
    exemplar = new QListViewItem( hai, "", "Sharpi", " 4" );
   QListViewItem* adler = new QListViewItem( lufttier, "Adler");
    exemplar = new QListViewItem( adler, "", "Scanner", " 6" );
    exemplar = new QListViewItem( adler, "", "Swing", " 7" );
   listview->resize( 300, 300 );
   listview->show();
   a.setMainWidget( listview );
   return a.exec();
}
