#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>

bool noflimmer;

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
public:
    malFenster() { setBackgroundMode( NoBackground ); }
protected:
    void paintEvent( QPaintEvent * ) {
       int   rx = width()/20,
             ry = height()/20;
       QPainter p( this );
       p.setPen( Qt::NoPen );

       for ( int i = 0; i < 10; i++ ) {
          QRect r1( rx*i, ry*i, width()-rx*2*i, height()-ry*2*i );
          if ( noflimmer )
             if ( i < 9 ) {
                QRect r2( rx*(i+1), ry*(i+1),
                          width()-rx*2*(i+1), height()-ry*2*(i+1) );
                p.setClipRegion( QRegion( r1 ).subtract( QRegion( r2 ) ) );
             } else
                p.setClipRegion( QRegion( r1 ) );
          p.setBrush( i%2 ? Qt::black : Qt::white );
          p.drawRect( r1 );
       }
    }
};

//..................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    noflimmer = ( argc > 1 && !strcmp( argv[1], "-n" ) );
    malFenster   bild;
    bild.setGeometry( 100, 100, 200, 200 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
