#include <qapplication.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <stdlib.h>
#include <time.h>
#include "overlayout.h"

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    int        i;
    ::srand( time( NULL ) );
    QWidget    *p     = new QWidget;
    QBoxLayout *bl    = new QHBoxLayout( p, 2 );
     //................................ Karten verschoben uebereinander legen
    QWidget    *w     = new QWidget( p );
    OverLayout *blatt = new OverLayout( w, 20 );
    QString s;
    for (i=0; i< 8; i++) {
       QPixmap karte;
       QLabel  *label = new QLabel( w );
       s.sprintf("%d.bmp", ::rand()%52+1 );
       karte.load( s );
       label->setPixmap( karte );
       label->setMaximumSize( karte.size() );
       blatt->add( (QWidget *)label );
    }
    bl->addWidget( w );
     //........... Farbblaetter (sind dehnbar) verschoben uebereinander legen
    w = new QWidget( p );
    QWidget  *f;
    OverLayout *farben = new OverLayout( w, 30 );
    for (i=0; i< 5; i++) {
       f = new QWidget( w );
       f->setPaletteBackgroundColor(
               QColor ( ::rand()&255, ::rand()&255, ::rand()&255 ) );
       farben->add( f );
    }
    bl->addWidget( w );

    a.setMainWidget( p );
    p->show();
    return a.exec();
}
