#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

//........................................................ Klasse MalFenster
class MalFenster : public QWidget
{
protected:
   virtual void paintEvent( QPaintEvent* ) {
      QString      text;
      QBrush       fuell( Qt::white);
      QPointArray  evenOdd, winding;
      QPainter     maler( this );

      maler.setBrush( fuell );

      text.sprintf("Even-Odd");
      maler.drawText( 40, 20, text ); 
      evenOdd.setPoints( 5, 50, 150, 100, 25, 150, 150, 25, 75, 175, 75 );
      maler.drawPolygon( evenOdd, false );

      text.sprintf("Winding");
      maler.drawText( 240, 20, text ); 
      winding.setPoints( 5, 250, 150, 300, 25, 350, 150, 225, 75, 375, 75 );
      maler.drawPolygon( winding, true );
   }
};

//..................................................................... main
int main( int argc, char *argv[] )
{
   QApplication myapp( argc, argv );

   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 0, 0, 400, 170 );

   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
