#include <qapplication.h>
#include <qpainter.h>
#include <qprinter.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main( int argc, char* argv[] )
{
   int  i;
   QApplication myapp( argc, argv );

   QWidget *dummy = new QWidget;

   srand( time (NULL ) );
   QPrinter meinDrucker;  // Einrichten eines QPrinter-Objekts

   //.... evtl. hier Standard-Einstellungen vornehmen
   // meinDrucker.setPrinterName( "training" );
   // meinDrucker.setPrintProgram( "lpr" );

   if ( meinDrucker.setup() ) { // nur, wenn Benutzer "OK" klickt
      QPainter druckerMaler( &meinDrucker );
     
      for (i= 0; i<20; i++)
         druckerMaler.fillRect(
               50+rand()%200, 50+rand()%200, rand() % 100, rand() % 100,
               QBrush(QColor( rand()%256, rand()%256, rand()%256 ) ) );

      if ( meinDrucker.newPage() ) //.... Seitenvorschub
         for (i= 0; i<20; i++)
            druckerMaler.drawEllipse( 50+rand()%200, 50+rand()%200,
                                      rand() % 100, rand() % 100 );
      return 0;
   }
   QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
   myapp.setMainWidget( dummy );
   return myapp.exec();
}
