#include <qapplication.h>
#include <qptrqueue.h>
#include <iostream>
#include <iomanip>

using namespace std;

int main(void)
{
   QPtrQueue<QString> queue;
   char               eingabe;
   char               name[100];
 
   queue.setAutoDelete( true );
   while (1) {
      cout << endl << endl
           << "a   Ankunft eines neuen Patienten\n"
              "b   Bedienung des naechsten Patienten\n"
              "q   Aktuellen Queue-Inhalt anzeigen\n"
              "e   Ende des Programms\n\n"
              "               Deine Wahl: ";
      cin >> eingabe;
      cout << endl;
      
      if (eingabe == 'e')
         break;

      else if (eingabe == 'a') {
         cout << "... Name des Patienten (als Buchstabe): ";
         cin >> name;
         QString *nam = new QString( name );
         queue.enqueue( nam );

      } else if (eingabe == 'b') {
         if ( queue.isEmpty() )
            cout << "...... Wartezimmer ist leer ...." << endl;
         else {
            cout << "...... '" << *queue.dequeue();
            cout  << "' wird nun bedient" << endl;
         }

      } else if (eingabe == 'q') {
         if ( queue.isEmpty() )
            cout << "...... Wartezimmer ist leer ...." << endl;
         else {
            QQueue<QString> tempQueue( queue );
            int             i=0;

            while ( !tempQueue.isEmpty() )
               cout <<setw(2) << ++i <<". " << *tempQueue.dequeue() <<endl;
         }
      }
   } 
   return 0;
}
