/****************************************************************************
** Form implementation generated from reading ui file 'textsize2.ui'
**
** Created: Sam Nov 29 11:34:30 2003
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.2.1   edited May 19 14:22 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "textsize2.h"

#include <qvariant.h>
#include <qlcdnumber.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qslider.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a TextSize as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
TextSize::TextSize( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "TextSize" );
    QFont f( font() );
    f.setFamily( "Times" );
    f.setPointSize( 18 );
    setFont( f ); 

    myLCDNumber = new QLCDNumber( this, "myLCDNumber" );
    myLCDNumber->setGeometry( QRect( 40, 130, 180, 100 ) );
    myLCDNumber->setNumDigits( 3 );
    myLCDNumber->setSegmentStyle( QLCDNumber::Filled );
    myLCDNumber->setProperty( "intValue", 10 );

    increment = new QPushButton( this, "increment" );
    increment->setGeometry( QRect( 140, 270, 80, 60 ) );
    increment->setPaletteBackgroundColor( QColor( 0, 255, 0 ) );

    textShow = new QLabel( this, "textShow" );
    textShow->setGeometry( QRect( 260, 50, 361, 291 ) );
    textShow->setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
    QFont textShow_font(  textShow->font() );
    textShow_font.setFamily( "Helvetica" );
    textShow_font.setPointSize( 11 );
    textShow->setFont( textShow_font ); 
    textShow->setAlignment( int( QLabel::AlignCenter ) );

    decrement = new QPushButton( this, "decrement" );
    decrement->setGeometry( QRect( 40, 270, 80, 60 ) );
    decrement->setPaletteBackgroundColor( QColor( 255, 0, 0 ) );

    mySlider = new QSlider( this, "mySlider" );
    mySlider->setGeometry( QRect( 50, 50, 171, 51 ) );
    mySlider->setMaxValue( 120 );
    mySlider->setValue( 10 );
    mySlider->setOrientation( QSlider::Horizontal );
    languageChange();
    resize( QSize(649, 433).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( decrement, SIGNAL( clicked() ), mySlider, SLOT( subtractStep() ) );
    connect( increment, SIGNAL( clicked() ), mySlider, SLOT( addStep() ) );
    connect( mySlider, SIGNAL( valueChanged(int) ), myLCDNumber, SLOT( display(int) ) );
    connect( mySlider, SIGNAL( valueChanged(int) ), this, SLOT( changeTextSizeSlot(int) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
TextSize::~TextSize()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void TextSize::languageChange()
{
    setCaption( tr( "Interactive change of font size" ) );
    increment->setText( tr( ">" ) );
    textShow->setText( tr( "Text" ) );
    decrement->setText( tr( "<" ) );
}

void TextSize::changeTextSizeSlot(int)
{
    qWarning( "TextSize::changeTextSizeSlot(int): Not implemented yet" );
}

