#include <qapplication.h>
#include <qpushbutton.h>
#include <qscrollview.h>
#include <qvbox.h>
#include <qpixmap.h>
#include <qlabel.h>
#include "rahmenlayout.h"

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );

    QWidget *w = new QWidget;

    RahmenLayout *large = new RahmenLayout( w );
    large->setSpacing( 5 );
    large->addWidget( new QPushButton( "Links", w ),  RahmenLayout::Links );
    large->addWidget( new QPushButton( "Rechts", w ), RahmenLayout::Rechts );
    large->addWidget( new QPushButton( "Unten", w ),  RahmenLayout::Unten );
    large->addWidget( new QPushButton( "Oben", w ),   RahmenLayout::Oben );

    QString s;
    QLabel *l;
    QScrollView *sv = new QScrollView( w );
    QVBox *g = new QVBox( sv->viewport() );
    sv->addChild( g );

    QPixmap bild;
    bild.load( "steintafeln.png" );
    l = new QLabel( "", g );
    l->setFrameStyle( QFrame::Box | QFrame::Sunken );
    l->setPixmap( bild );
    sv->repaint();
    large->addWidget( sv, RahmenLayout::Mitte );
    large->addWidget( new QPushButton( "Rechts innen", w ), RahmenLayout::Rechts);

    a.setMainWidget( w );
    w->resize( 500, 300 );
    w->show();

    return a.exec();
}
