#include <qapplication.h>
#include <qdatetime.h>
#include <qlabel.h> 
#include <qpushbutton.h>
#include <qdatetime.h>
#include <stdlib.h>
//....................................................... Klasse reaktionsTest
class reaktionsTest : public QWidget {
   Q_OBJECT
public:
    reaktionsTest( QWidget *p=0, const char *t=0) : QWidget( p, t ) {
       rekord = 1000000000;
       QPushButton *b = new QPushButton( "Beenden", this );
        b->setGeometry( 30, 10, 400, 30 );
        QObject::connect( b, SIGNAL(clicked()), qApp, SLOT(quit()) );
       QPushButton *s = new QPushButton( "Starte Reaktionstest", this );
        s->setGeometry( 30, 50, 400, 30 );
        QObject::connect( s, SIGNAL(clicked()), this, SLOT( starteReakTest()) );
       zeitLabel = new QLabel( this );
        zeitLabel->setGeometry( 30, 150, 400, 150 );
    }
private slots:
    void starteReakTest() {
       stoppUhr.start();
       int x = 1000 + rand()%3000;
       while (1) 
          if (stoppUhr.elapsed() > x)
            break;
       stoppUhr.restart();
       reakButton= new QPushButton( "Schnell klicke mich", this );
       reakButton->setGeometry( 30, 50, 400, 300 );
       reakButton->setPaletteBackgroundColor( Qt::green );
       reakButton->show();
       QObject::connect( reakButton, SIGNAL(pressed()), this, SLOT( gedrueckt()) );
    }
    void gedrueckt() {
       int ms = stoppUhr.elapsed();
       QString  z;
       if ( ms < rekord )
          rekord = ms;
       z.sprintf(" Deine gebrauchte Zeit ist: %d msec\n"
                 " Dein Rekord ist: %d msec\n", ms, rekord);
       zeitLabel->setText( z );
       if ( ms == rekord )
          zeitLabel->setPaletteBackgroundColor( Qt::red );
       else
          zeitLabel->setPaletteBackgroundColor( Qt::white );
       delete reakButton;
    }
private:
    QLabel       *zeitLabel;
    QTime        stoppUhr;
    QPushButton  *reakButton;
    int          rekord;
};
#include  "reaktest.moc"
//....................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   srand( time(NULL) );
   QWidget* mywidget = new reaktionsTest(); 
    mywidget->setGeometry( 200, 100, 450, 350 ); 
   myapp.setMainWidget( mywidget );
    mywidget->show();
   return myapp.exec();
}
