#include  <qapplication.h>
#include  <qstring.h>
#include  <qregexp.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <stdlib.h>
#include  <stdio.h>

int  main( int argc, char *argv[] ) {
   QString      msg;
   QApplication a( argc, argv );
   if (argc != 3) {
      msg.sprintf( "usage:  %s pattern dateiname", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }
   QFile datei( argv[2] );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[2] );
      QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                msg, QMessageBox::Ok );
      return 2;
   } else {
      QString  zeile, wort;
      int      r, zeilnr=1;
                
      QRegExp  wortRA( "\\w+" ); // Worttrennzeichen (normaler Modus fuer RA)
      QRegExp  regAusdruck( argv[1], true, true ); // RA von Kdozeile
      while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
         if ( r == -1 ) {
            if ( !datei.atEnd() ) {
               msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[2] );
               QMessageBox::information( 0, "Fehler beim Lesen",
                                         msg, QMessageBox::Ok );
               return 3;
            }
            break;
         } else {
            bool erst = true;
            int  len, offset = 0;
              //... Zeile in Worte zerlegen, und jedes Wortpruefen, ob es durch
              //... den vom Benutzer auf Kdozeile angegebenen RA abgedeckt wird
            while ( ( offset = wortRA.search( zeile, offset ) ) >= 0 ) {
               len = wortRA.matchedLength();
               wort = zeile.mid( offset, len );  
               if ( regAusdruck.exactMatch( wort ) )
                  if ( erst ) {
                     fprintf( stdout, "%5d: %s", zeilnr, (const char *)wort );
                     erst = false;
                  } else
                     fprintf( stdout, ", %s", (const char *)wort );
               offset += len;
            } 
            if ( !erst )
               printf("\n");
            zeilnr++;
         }
      }
      datei.close();
   }
   return 0;
}
