#include  <qapplication.h>
#include  <qstring.h>
#include  <qregexp.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <stdio.h>

int  main( int argc, char *argv[] ) {
   QString      msg;
   QApplication a( argc, argv );
   if (argc != 2) {
      msg.sprintf( "usage:  %s dateiname", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }
   QFile datei( argv[1] );
   if ( !datei.open( IO_ReadOnly ) ) {
      msg.sprintf( "Datei `%s' kann nicht geffnet werden", argv[1] );
      QMessageBox::information( 0, "Fehler beim ffnen der Datei",
                                msg, QMessageBox::Ok );
      return 2;
   } else {
      QString  zeile;
      int      r, zeilnr=1;
      QRegExp  isbnNummer( "[0-9]-?"
                           "[0-9][0-9][0-9][0-9][0-9]-?[0-9][0-9][0-9]-?"
                           "[0-9xX]" );
      while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
         if ( r == -1 ) {
            if ( !datei.atEnd() ) {
               msg.sprintf( "Fehler beim Lesen der Datei `%s'", argv[1] );
               QMessageBox::information( 0, "Fehler beim Lesen",
                                         msg, QMessageBox::Ok );
               return 3;
            }
            break;
         } else {
            int      wert=0, z=0, len;
            QString  text( zeile ), t, p;
            zeile = zeile.stripWhiteSpace();
            len = zeile.length();
            if ( isbnNummer.exactMatch( zeile ) ) {
               for ( int i=0; i<len-1; i++ )
                   if ( zeile[i].isDigit() )
                      wert += zeile[i].digitValue() * ++z; 
               wert %= 11;
               p.sprintf( "%c", (wert<10) ? wert+'0' : 'X' );
               if ( QString( zeile[len-1] ) == p )
                  zeile += " <----- richtig";
               else {
                  t.sprintf( " .........falsche Prfziffer (%s erwartet)", (const char *)p );
                  zeile += t;
               }
            } else
               zeile += " .........falsches Format";
            fprintf( stdout, "%5d: .... %s\n", zeilnr, (const char *)zeile );
            zeilnr++;
         }
      }
      datei.close();
   }
   return 0;
}
