#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <stdio.h>

int  main( int argc, char *argv[] )
{
   QString      msg;
   int          zeichenGesamt=0,
                zeilenGesamt = 0;
   QApplication a( argc, argv );

   if (argc < 2) {
      msg.sprintf( "usage:  %s dateinam(e)", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   for ( int i=1; i<argc; i++) {
      QFile datei( argv[i] );
      bool  error = false;

      if ( !datei.open( IO_ReadOnly ) )
         printf("%7d %8d %s (kann sie nicht oeffnen)\n", 0, 0, argv[i] );
      else {
         QString zeile;
         int   zeichen = 0, zeilen = 0, r;
         while ( ( r = datei.readLine( zeile, 1000 ) ) != 0 ) { 
            if ( r == -1 ) {
               if ( !datei.atEnd() )
                  error = true;
               break;
            } else {
               zeichen += r;
               zeilen++;
            }
         }
         datei.close();
         zeichenGesamt += zeichen;
         zeilenGesamt  += zeilen;
         printf("%7d %8d %s%s\n", zeilen, zeichen, argv[i], 
                (error == true) ? "(Fehler beim Lesen)" : "" );
      }
   }
   printf("-------------------------------------------------\n");
   printf("%7d %8d insgesamt\n", zeilenGesamt, zeichenGesamt );
   return(0);
}   
