#include  <qapplication.h>
#include  <qpixmap.h>
#include  <qlabel.h>

int main( int argc, char *argv[] )
{
   QApplication  myapp( argc, argv );

   QWidget* mywidget = new QWidget();
   mywidget->setGeometry( 20, 20, 400, 120 );

   QString  dateiname;
   bool     fehler = false;
   QPixmap  bild;

   if ( argc < 2 ) {
      dateiname += "Kein Dateiname auf der Kommandozeile angegeben";
      fehler = true;
   } else if (argc > 2) {
      dateiname += "Mehr als ein Dateiname auf der Kommandozeile angegeben";
      fehler = true;
   } else if ( !bild.load( argv[1] ) ) {
      dateiname += "Kann angegebene Datei nicht oeffnen";
      fehler = true;
   }

   if ( fehler == true ) {
      QLabel* fehlanzeig = new QLabel( dateiname, mywidget );
      fehlanzeig->setGeometry( 0, 0, 400, 120 );
      fehlanzeig->setPalette( QPalette( Qt::red, Qt::red ) );
      fehlanzeig->setAlignment( QLabel::AlignCenter );

   } else {
      QLabel* bildlabel = new QLabel( mywidget );
      mywidget->resize( bild.width()+20, bild.height()+20 );
      mywidget->setPaletteBackgroundColor( Qt::black );
      bildlabel->setPixmap( bild );
      bildlabel->setGeometry( 10, 10, bild.width(), bild.height());
      bildlabel->resize( bild.size() );
   }

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
