#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "zoo.h"
      //................................................ Namensvorgaben
char *namen[] = { "Wotan", "Pluto", "Maya", "Lukas", "Flipper",
                  "Tarzan", "Kucki", "Slappi", "Fury" };
int namzahl = sizeof(namen) / sizeof(namen[0]);
      //....................... Anlegen der einzelnen Spezies (Klassen)
SPEZIES(CHund,  CLandtier, "Hund", "bellen")
SPEZIES(CKatze, CLandtier, "Katze", "schnurren")
SPEZIES(CMaus,  CLandtier, "Maus", "Loecher graben")
SPEZIES(CSchmetterling, CLufttier, "Schmetterling", "flattern")
SPEZIES(CBiene,         CLufttier, "Biene", "summen")
SPEZIES(CVogel,         CLufttier, "Vogel", "zwitschern")
SPEZIES(CWal, CWassertier, "Wal", "tief tauchen")
SPEZIES(CHai, CWassertier, "Hai", "gut beissen")

int z = 8;  // z enthlt Anzahl der zur Verfuegung stehenden Spezies
      //............................................ CZoo (Konstruktor)
CZoo::CZoo(int tierzahl) {
                   //... Erzeugen von zufaelligen Tieren (Objekten)
   m_Tierzahl = tierzahl; // geforderte Anzahl von Tieren
   srand(time(NULL));
   m_Tiere = new CTier *[tierzahl];
   for (int i=0; i<m_Tierzahl; i++) {
      int welch_name = rand()%namzahl;
      switch ( rand()%z ) {
          case 0: m_Tiere[i] = new CHund( namen[welch_name] );          break;
          case 1: m_Tiere[i] = new CKatze( namen[welch_name] );         break;
          case 2: m_Tiere[i] = new CMaus( namen[welch_name] );          break;
          case 3: m_Tiere[i] = new CSchmetterling( namen[welch_name] ); break;
          case 4: m_Tiere[i] = new CBiene( namen[welch_name] );         break;
          case 5: m_Tiere[i] = new CVogel( namen[welch_name] );         break;
          case 6: m_Tiere[i] = new CWal( namen[welch_name] );           break;
          case 7: m_Tiere[i] = new CHai( namen[welch_name] );           break;
      }
   }
}
      //........................................................... Get
CTier *CZoo::Get(int tiernr) {
   if (tiernr >=0 && tiernr < m_Tierzahl)
      return m_Tiere[tiernr];
   return NULL;
}
      //...................................................... Printall
void CZoo::Printall(void) {
   for (int i=0; i<m_Tierzahl; i++) {
      m_Tiere[i]->als_individuum_bin_ich();
      m_Tiere[i]->als_spezies_kann_ich();
      m_Tiere[i]->ich_kann();
   }
}
